package koeln.uni.idh.java1.session10.zoo;

import koeln.uni.idh.java1.session10.zoo.animals.Alpaca;
import koeln.uni.idh.java1.session10.zoo.animals.Animal;
import koeln.uni.idh.java1.session10.zoo.animals.Horse;
import koeln.uni.idh.java1.session10.zoo.animals.ZooObject;
import koeln.uni.idh.java1.session10.zoo.ui.AsciiImage;

public class Zoo {

	static String[] names = new String[] { "Alexandra", "Alice", "Aline", "Anastasia", "Ander", "Andrea", "Andreas",
			"Anja", "Anke", "Ann", "Anna", "Anne", "Antor", "Aria", "Astrid", "Axel", "Barbara", "Beatrice", "Beatrix",
			"Benjamin", "Bettina", "Bieke Verle", "Birgit", "Björn", "Carlo", "Catherine", "Christian", "Christiane",
			"Christine", "Christof", "Christoph", "Claudia", "Daniel", "Dany", "David", "Debora", "Dennis", "Dominik",
			"Eckhard", "Edwin", "Eleftheria", "Esther", "Etienne", "Eugen", "Fabian", "Federico", "Felix", "Fiorella",
			"Folkart", "Frank", "Gabriele", "Gabriella", "Gesine", "Gisa", "Gudrun", "Habbo", "Hans-Joachim",
			"Hans-Peter", "Heidrun", "Heike", "Heinz", "Isolde", "Jan Felix", "Joachim", "Jörg", "Judith", "Julia",
			"Jürgen", "Karl", "Katajun", "Katharina", "Klaus", "Kristina", "Magnus", "Marco", "Marcus", "Maren Janika",
			"Maria-Theresia", "Marina", "Marita", "Martin", "Martine", "Michael", "Michaela", "Monika", "Nadine",
			"Nicolas", "Nicole", "Nikolaus", "Nikolaus P.", "Nils", "Nora", "Øyvind", "Paul", "Peter", "Peter Franz",
			"Peter W.", "Peter Werner", "Petra", "Ralph", "René", "Richard", "Rie", "Roman", "Ruth", "Sabine", "Sandra",
			"Sebastian", "Sebastião", "Sieglinde", "Silke", "Silviane", "Sophie", "Stefan", "Stephan",
			"Stephan Michael", "Susanne", "Susanne Katrin", "Sven", "Thiemo", "Thiemo Rafael", "Thomas", "Thoralf",
			"Thorsten", "Tobias", "Torsten", "Ulrike", "Ute", "Walter", "Werner", "Wiebke", "Wilfried", "Wolfgang",
			"Wolfram" };

	Animal[] animals;
	
	IsDrawable[] objects;
	
	int size;

	public Zoo(int size, int numberOfAnimals) {
		this.size = size;

		
		// generate and position animals
		this.animals = new Animal[numberOfAnimals];
		for (int a = 0; a < this.animals.length; a++) {
			if (Math.random() < 0.5)
				this.animals[a] = new Horse(names[Util.randInt(0, names.length)]);
			//else if (Math.random() > 0.9)
			//	this.animals[a] = new Animal(names[Util.randInt(0, names.length)]);
			else
				this.animals[a] = new Alpaca(names[Util.randInt(0, names.length)]);

			this.animals[a].setX(Util.randInt(1, size - 1));
			this.animals[a].setY(Util.randInt(1, size - 1));
		}
		
		this.objects = new IsDrawable[2];
		this.objects[0] = new ZooObject(3,3);
		this.objects[1] = new ZooObject(3,4);
	}

	public void draw() {
		AsciiImage ai = new AsciiImage(size, size);
		for (int h = 0; h < animals.length; h++) {
			ai.dot(animals[h].getX(), animals[h].getY(), animals[h]);
		}
		for (int h = 0; h < objects.length; h++) {
			ai.dot(objects[h].getX(), objects[h].getY(), objects[h]);
		}

		
		System.out.println(ai);
	}

	public static void main(String[] args) {
		Zoo zoo = new Zoo(15, 5);
		zoo.draw();
	}

}
